/* An addon for for SREhttp/2 --
   View and modify Sre2000 parameters

 Note that SUPERUSER privs are REQUIRED to run this -- irrespective 
 of ATTRIBS.CFG settings.

 */

/* ---------------- USER CONFIGURABLE PARAMETERS  ------------------ */

No_remote=0     /* 0 = just check for SUPERUSER priv
                   1 = allow web-based if client and server ip addresses are the same
                       (also check for SUPERUSER priv)
                   2 = suppress ALL web-based configuration   */


/* ---------------- DO NOT MODIFY BELOW THIS LINE  ------------------ */

parse arg  ddir, tempfile, reqstrg,list,verb ,uri,user, ,
          basedir ,workdir,privset,enmadd,transaction,verbose, ,
         servername,host_nickname,homedir,aparam,semqueue,prog_file,reqnum


if verb="" then do
   say " This SREhttp/2 addon is not meant to be run in stand-alone mode. "
   exit
end  /* Do */


signal on error name badguys
signal on syntax name badguys


crlf = '0d0a'x

foo=check_access(privset,no_remote)
if foo<>'' then return foo

/* initial request -- then allow one to select options */
if list=''  then do
   foo=do_srecfg()
   return foo
end 


params.=''
oldlist=list
do until list=''
  parse var list a1 '&' list
  parse var a1 a1a '=' a1b
  a1a=strip(translate(a1a))
  a1b=translate(a1b,' ','0d0a0900'x)
  vv='!'||a1a
  params.vv=a1b  
end 


/* what ACTION is it? */
aact=strip(translate(params.!ACTION))
select
  when aact='REQCACHE' then do
     list=oldlist
     call do_reqcache
     ares=result

  end 
  when aact='MD5CACHE' then do
     call do_md5cache
     ares=result
  end 
  when aact='USERCACHE' then do
     call do_usercache
     ares=result

  end 
  when aact='IPNAMECACHE' then do
     call do_ipnamecache
     ares=result

  end 
  when aact='COUNTERS' then do
     call do_counters
     ares=result

  end 
  when aact='SYSVARS' then do
     call do_sysvars
     ares=result
  end 

  when aact='STATVALS' then do
     call do_statvals
     ares=result
  end 

  when aact='CLIENTS' then do
     call do_clients
     ares=result
  end 

  when aact='TRACKING' then do
      call do_client_tracking
      ares=result
  end 

  otherwise
     ares=sre_command('String No such SRE_CFG action: 'aact)
  end

  return ares




/******************************************/
/* view tracking info on current clients */
do_client_tracking:

call lineout tempfile,'<HTML><HEAD><TITLE>Viewing  Sre2000 Tracking info </TITLE></head>'
call lineout tempfile,'<BODY><h3>Viewing  Sre2000 Tracking info for current clients</h3>'

call lineout tempfile,'<li><a href="/SRE2_CFG?ACTION=TRACKING&TODO=SUMMARY">Summary view </a>'
call lineout tempfile,'<li><a href="/SRE2_CFG?ACTION=TRACKING&TODO=REPORT">Full Report view </a>'

call lineout tempfile,'</ul>'

tt=sre_sysvars('TRACKING_ON')
if tt=0 then do
   call lineout tempfile,' <b>Tracking is not currently enabled </b>'
   signal tdone
end

if params.!TODO='REPORT' then do
  clist=sre_localvars('!CLIENTLIST')
  allvars=sre_trackit('**',,clist)
  call lineout tempfile,'<em>All parameters for currently active clients: 'clist'</em><p>'
  call lineout tempfile,'<pre>ClientID   VarName         Value'
  oldid=' '
  do until allvars=''
     parse var allvars aline '0d0a'x allvars
     parse var aline jcl vvar ':' vval
     if oldid<>jcl  | oldid=' ' then do
        if oldid<>jcl then call lineout tempfile,' '
        oldid=jcl
     end 
     else do
        jcl=' '
     end 
     jcl=left(jcl,9,' ')
     vvar=left(vvar,max(16,lengtH(vvar)+1),' ')
     call lineout tempfile,jcl||vvar||vval
  end 
  call lineout tempfile,'</pre>'

  signal t_done
end


if params.!TODO='DETAIL' then do
  iclient=params.!CLIENT
  itrans=params.!TRANSACTION
  call lineout tempfile,'<h3>Tracking info for client # 'iclient '</h3>'
  oo=sre_trackit('**',,iclient,itrans)

  if oo='' then do
    call lineout tempfile,'<b>Unavailable!</b> (transaction 'itrans' has terminated)' 
    signal t_done
  end
  a1=''
  call lineout tempfile,'<table><Tr><th>Variable</th><th>Value</th>'
  do until oo=''
        parse var oo aline '0d0a'x oo
        parse var aline daclient davar ':' daval
        call lineout tempfile,'<tr><th align="LEFT">'davar'</th><td><tt>&nbsp;&nbsp;'daval'</td></tr>'
  end 
  call lineout tempfile,'</table>'     
  signal t_done
end 

this1=sre_localvars('CLIENT')
clist=sre_localvars('!CLIENTLIST')

allvars=sre_trackit('* CLIENTADDR SELECTOR TRANSACTION START_TIME',,clist)

tt.=''
vs.=''
do ww=1 to words(clist)
    tt.ww=strip(word(clist,ww))
end 

/* parse the results */
do until allvars=''
   parse var allvars aline '0d0a'x allvars
   parse var aline iclient vname ':' vval
   ith1=wordpos(iclient,clist)
   vname='!'||strip(translate(vname))
   tt.ith1.vname=vval
end 

v3='!*' ; v1='!CLIENTADDR'; v2='!SELECTOR' ; v4='!TRANSACTION'
v5='!START_TIME'


call lineout tempfile,'<h3>Current time: '||date('b')||' 'time('l')||'</h3>'
call lineout tempfile,'To see details on a transaction, click on the '
call lineout tempfile,'<u>transaction number</u> <EM>(if the transaction has terminated,'
call lineout tempfile,'tracking information will not be available)</em><p>'
call lineout tempfile,'<table border=0 cellpadding=2>'

call lineout tempfile,'<tr>'
call lineout tempfile,'<th>Transaction <br> &amp; <em>ClientID </th>'
call lineout tempfile,'<th>Client Address <br> &amp; <font size="-1">start time</font></th>'
call lineout tempfile,'<th><tt>Selector</tt></th><TH><font size="-1">VarList</font></th>'
do mm=1 to words(clist)
  aid=tt.mm
  addr=tt.mm.v1
  atrans=tt.mm.v4
  stime=tt.mm.v5

  if aid=this1 then
     adetail='<B>'atrans'</b> <em>'aid'</em>'
  else
     adetail='<a href="/sre2_cfg?action=TRACKING&TODO=DETAIL&CLIENT='aid|| ,
              '&TRANSACTION='atrans'">'atrans'</a> <em>'aid'</em>'
  call lineout tempfile,'<tr><td>'|| adetail || '</td>'

  call lineout tempfile,'<td>'||addr||'<br><font size="=1">'||stime||'</font>&nbsp;&nbsp;</td>'

  ssel=break_it(tt.mm.v2,40)
  call lineout tempfile,'<td><tt>'||ssel ||'</tt></td>'

  vll=fatspace(tt.mm.v3)
  call lineout tempfile,'<td><font size="-1">'|| vll   ||'</font></td></tr>'

end
call lineout tempfile,'</table>'


t_done:
call lineout tempfile,'<hr> <a href="/sre2_cfg?">Return to Sre2000 parameter viewer </a>'
call lineout tempfile,'</BODY></HTML>'
call lineout tempfile
aa=sref_gos('FILE ERASE type text/html name 'tempfile)
return aa

/******************/
/* make ' ' into &nbsp;&nbsp; */
fatspace:procedure
parse arg aline
newl=''
do until aline=''
   parse var aline aword aline
   if newl='' then
        newl=aword' '
   else
      newl=newl||'&nbsp;&nbsp; '||aword
end 
return newl

/******************/
/* break a long line into llen <br> chunks */
break_it:procedure
parse arg aline,llen
if length(aline)<llen then return aline||'&nbsp;&nbsp;'

al=''
newl=''
do until aline=''
   parse var aline a1 '&' aline
   if aline<>'' then a1=a1||'&'
   al1=al1||a1
   if length(al1)>40 then do
        newl=newl||al1
        if aline<>"" then newl=newl||'&nbsp;&nbsp;<br>'
        al1=''
   end 
end
if al1<>'' then newl=newl||al1||'&nbsp;&nbsp;'
return newl




/******************************************/
/* view current clients */
do_clients:

call lineout tempfile,'<HTML><HEAD><TITLE>Viewing  Sre2000 Current Clients </TITLE></head>'
call lineout tempfile,'<BODY><h3>Viewing  Sre2000 Current Clients</h3>'

call lineout tempfile,'<ul><li><a href="/SRE2_CFG?ACTION=CLIENTS&TODO=SHUTDOWN">ShutDown Sre2000 </a>'
call lineout tempfile,'<li><a href="/SRE2_CFG?ACTION=CLIENTS&TODO=DETAILS">Details view </a>'
call lineout tempfile,'<li><a href="/SRE2_CFG?ACTION=CLIENTS&TODO=SUMMARY">Summary view </a>'
call lineout tempfile,'</ul>'

if params.!TODO='SHUTDOWN' then do
    foo=sre_shutdown('From SRE2_CFG')
    call lineout tempfile,'<em>Shutting down Sre2000 ('foo') ... </em>'
    call lineout tempfile,'<hr> <a href="/sre2_cfg?">Return to Sre2000 parameter viewer </a>'
    call lineout tempfile,'</BODY></HTML>'
    aa=sref_gos('FILE ERASE type text/html name 'tempfile)
    return aa
end 


select 
 when params.!DOSTUFF=1 then do             /* kill a client */
   parse var params.!kill  partid '_' acli '_' wastrans .
   kidtid=sre_localvars('TID',acli)
   nuflag=translate(sre_localvars('STARTTIME',,kidtid))
   parse var nuflag . nutrans . ; nutrans=strip(nutrans)
   if nutrans<>wastrans then do
      call lineout tempfile,' <b> No such transaction: 'wastrans'</b>'
   end 
   else do
      asock=sre_localvars('SOCKET',,kidtid)
      mypid=dospid()
      call lineout tempfile,'<h3> Killing transaction 'wastrans' </h3><menu>'

      tthreads=RxListThreads(mypid)        /* AVOID problems of trying to kill nonexisteent thread */
      if wordpos(kidtid,tthreads)>0 then  do  /* kid thread is still alive-- kill it */
         foo=rxprcKillThread(kidtid)                
         if foo<>0 then do
            call lineout tempfile,'<li><b> Unable to kill request thread: 'kidtid'</b><br>'
         end
         else do
            call lineout tempfile,'<li><b> Kill request thread (on 'kidtid'</b><br>'
         end
      end        
      if wordpos(partid,tthreads)>0 then  do  /* kid thread is still alive-- kill it */
         foo=rxprcKillThread(partid)                
         if foo<>0 then do
            call lineout tempfile,'<li><b> Unable to kill transaction thread: 'partid'</b><br>'
         end
         else do
            call lineout tempfile,'<li><b> Kill transaction thread (on 'partid'</b><br>'
         end
      end   

     rc=sockshutdown(asock,2)
     rc = SockClose(asock)
     if rc<>0 then do 
        serr=socksock_errno()
        call lineout tempfile,'<li><b>Error closing socket 'asock': 'serr'</b></br>'
     end 
     else do
        call lineout tempfile,'<li><b>Socket 'asock ' closed </b></br>'
     end 

 
     fop=sre_localvarS('!CLEAR',acli)
     if fop='1' then
        call lineout tempfile,'<li> <b>Transaction information cleared </b><p>'
     else
        call lineout tempfile,'<li> <b>Error clearing transaction information: 'fop' </b><p>'


     call lineout tempfile,'</menu>'
   end
 end 

 when params.!TODO='DETAILS' then do
   this1=sre_localvars('CLIENT')
   fff=sre_localvars('!CLIENTLIST')

    call lineout tempfile,'<form action="/SRE2_CFG" method=GET >'
    call lineout tempfile,'<Input type="hidden" name="ACTION" value="CLIENTS">'
    call lineout tempfile,'<Input type="hidden" name="DOSTUFF" value="1">'
    call lineout tempfile,'<h3>Current time: '||date('b')||' 'time('l')||'</h3>'
    call lineout tempfile,'<table border=0 cellpadding=2>'

    call lineout tempfile,'<tr><th>Kill</th>'
    call lineout tempfile,'<th><tt>Client<br>ID<tt></th><th>Socket & <br> Transaction </th><th>Client<br>address</th>'
    call lineout tempfile,'<th>Start Time </th><th>[Host :] Selector </th></tr>'
    do mm=1 to words(fff)
      acl=strip(word(fff,mm))


/* kidtid=sre_localvars('TID',acl)
   vlist=sre_localvars('VARLIST',,kidtid)
  call pmprintf(" vars in "vlist)   */

      goo=sre_localvars('!INFO',acl)
      parse var goo ac2 '0d0a'x asocket '0d0a'x  iscomp '0d0a'x caddr '0d0a'x starttime ,
        '0d0a'x hostnick '0d0a'x asel
      parse var starttime partid atrans adate atime
      call lineout tempfile,'<tr>'
      if acl=this1 then
          call lineout tempfile,' <td> o </td> '
      else
         call lineout tempfile,'<td><input type="RADIO" name="KILL" ',
                         'value="'partid||'_'||acl||'_'||atrans||'"></td>'
    
      call lineout tempfile,'<td><tt>'ac2'</tt></td>'
      elem1='' ; elem2=''
      if iscomp=1 then do
         elem1='<em>' ;elem2='</em>'
      end 
      if acl=this1 then do
         elem1='<b>'||elem1 ;elem2=elem2||'</b>'
      end 
      call lineout tempfile,'<td>'elem1||asocket||elem2||'<br>'||atrans||'</td>'
      call lineout tempfile,'<td>'caddr'</td><td><font size=-1>'adate'</font> 'atime'</td>'

      call lineout tempfile,'<td>'
      if hostnick<>'' then call lineout tempfile,hostnick ': '
      call lineout tempfile, asel '</td></tr>'
   end 
   call lineout tempfile,'</table>'
   call lineout tempfile,'<input type="Submit" value="Kill a connection..">'
   call lineout tempfile,'<input type="Reset">'

   call lineout tempfile,'</table>'
 end

 otherwise do
   foo=sre_localvars('!INFO')
   call lineout tempfile,'<pre>'||foo
   call lineout tempfile,'</pre>'
 end
end
call lineout tempfile,'<hr> <a href="/sre2_cfg?">Return to Sre2000 parameter viewer </a>'
call lineout tempfile,'</BODY></HTML>'
call lineout tempfile
aa=sref_gos('FILE ERASE type text/html name 'tempfile)
return aa


/******************************************/
/* the username cache viewer */
do_usercache:

call lineout tempfile,'<HTML><HEAD><TITLE>Viewing the Sre2000 Username Cache </TITLE></head>'
call lineout tempfile,'<BODY><h3>Viewing the Sre2000 Username/Password Cache </h3>'
call lineout tempfile,'<a href="/SRE2_CFG?ACTION=USERCACHE&TODO=RESET">Reset Username/Password cache? </a><hr width="30%">'
if params.!TODO='RESET' then do
    ooop=value('SREF_USERCACHE_RESET',1,'os2environment')
    call lineout tempfile,'<em>Username/password cache will be cleared ... </em>'
    call lineout tempfile,'<hr> <a href="/sre2_cfg?">Return to Sre2000 parameter viewer </a>'
    call lineout tempfile,'</BODY></HTML>'
    aa=sref_gos('FILE ERASE type text/html name 'tempfile)
    return aa
end 

foo=sre_cache1('!INFO')
call lineout tempfile,'<pre>'||foo
call lineout tempfile,'</pre>'
call lineout tempfile,'<hr> <a href="/sre2_cfg?">Return to Sre2000 parameter viewer </a>'
call lineout tempfile,'</BODY></HTML>'
call lineout tempfile
aa=sref_gos('FILE ERASE type text/html name 'tempfile)
return aa


/******************************************/
/* view system variables */
do_sysvars:

call lineout tempfile,'<HTML><HEAD><TITLE>Viewing the Sre2000 System Variables </TITLE></head>'
call lineout tempfile,'<BODY><h3>Viewing the Sre2000 System Variables</h3>'

foo=sre_sysvars('!INFO')
call lineout tempfile,'<pre>'||foo
call lineout tempfile,'</pre>'
call lineout tempfile,'<hr> <a href="/sre2_cfg?">Return to Sre2000 parameter viewer </a>'
call lineout tempfile,'</BODY></HTML>'
call lineout tempfile
aa=sref_gos('FILE ERASE type text/html name 'tempfile)
return aa


/******************************************/
/* view system variables */
do_statvals:

call lineout tempfile,'<HTML><HEAD><TITLE>Viewing  Sre2000 Recent Stats </TITLE></head>'
call lineout tempfile,'<BODY><h3>Viewing  Sre2000 Recent Stats</h3>'

call lineout tempfile,'<ul><li><a href="/SRE2_CFG?ACTION=STATVALS&TODO=RESET">Reset Sre2000 Recent Stats  </a>'
call lineout tempfile,'<li><a href="/SRE2_CFG?ACTION=STATVALS&TODO=DETAILS">Details view </a>'
call lineout tempfile,'<li><a href="/SRE2_CFG?ACTION=STATVALS&TODO=SUMMARY">Summary view </a>'
call lineout tempfile,'</ul>'

varlist=sre_savevals('!VARLIST')

if params.!TODO='RESET' then do
    foo=sre_savevals('!RESET')
    call lineout tempfile,'<em>Sre2000 recent stats cleared: ('foo') ... </em>'
    call lineout tempfile,'<hr> <a href="/sre2_cfg?">Return to Sre2000 parameter viewer </a>'
    call lineout tempfile,'</BODY></HTML>'
    aa=sref_gos('FILE ERASE type text/html name 'tempfile)
    return aa
end 

if params.!TODO='DETAILS' then do
   foo=sre_savevals('!VALUES')
end
else do
   foo=sre_savevals('!INFO')
end
call lineout tempfile,'<pre>'||foo
call lineout tempfile,'</pre>'

/* get some stats for the several vars */
if params.!todo<>'DETAILS' then do
   /* sum mean sd minmax */
   call lineout tempfile,' <TABLE BORDER="1" ALIGN="CENTER" CELLSPACING="11" CELLPADDING="00" WIDTH="80%" >'
   call lineout tempfile,'<tr><th>Variable<br>Name</th><th># obs</th><th>SUM</th><TH>MEAN</th><th>SD</th><th>MinMax</th></tr>'

   do mm=1 to words(varlist)
       call lineout tempfile,'<tr>'
       avar=strip(word(varlist,mm))
       call lineout tempfile,'<th>'avar'</th>'

       a1=sre_savevals('NOBS',avar)
       call lineout tempfile,'<td>'a1'</td>'

       a1=sre_savevals('SUM',avar)
       call lineout tempfile,'<td>'a1'</td>'

       a1=sre_savevals('MEAN',avar)
       call lineout tempfile,'<td>'a1'</td>'

       a1=sre_savevals('SD',avar)
       call lineout tempfile,'<td>'a1'</td>'

       a1=sre_savevals('MINMAX',avar)
       call lineout tempfile,'<td>'a1'</td>'
       call lineout tempfile,'</tr>'
   end
   call lineout tempfile,'</table>'

end 

call lineout tempfile,'<hr> <a href="/sre2_cfg?">Return to Sre2000 parameter viewer </a>'
call lineout tempfile,'</BODY></HTML>'
call lineout tempfile
aa=sref_gos('FILE ERASE type text/html name 'tempfile)return aa



/******************************************/
/* view counter variablese */
do_counters:

call lineout tempfile,'<HTML><HEAD><TITLE>Viewing the Sre2000 Counters </TITLE></head>'
call lineout tempfile,'<BODY><h3>Viewing the Sre2000 Counters</h3>'
call lineout tempfile,'<a href="/SRE2_CFG?ACTION=COUNTERS&TODO=RESET">Reset Sre2000 Counters  </a><hr width="30%">'
if params.!TODO='RESET' then do
    foo=sre_countvars('!RESET')
    call lineout tempfile,'<em>Sre2000 counters cleared: ('foo') ... </em>'
    call lineout tempfile,'<hr> <a href="/sre2_cfg?">Return to Sre2000 parameter viewer </a>'
    call lineout tempfile,'</BODY></HTML>'
    aa=sref_gos('FILE ERASE type text/html name 'tempfile)
    return aa
end 

foo=sre_countvars('!INFO')
call lineout tempfile,'<pre>'||foo
call lineout tempfile,'</pre>'
call lineout tempfile,'<hr> <a href="/sre2_cfg?">Return to Sre2000 parameter viewer </a>'
call lineout tempfile,'</BODY></HTML>'
call lineout tempfile
aa=sref_gos('FILE ERASE type text/html name 'tempfile)
return aa


/******************************************/
/* the IPname cache viewer */
do_IPNAMEcache:

call lineout tempfile,'<HTML><HEAD><TITLE>Viewing the Sre2000 IPname Cache </TITLE></head>'
call lineout tempfile,'<BODY><h3>Viewing the Sre2000 IPname Cache </h3>'
call lineout tempfile,'<a href="/SRE2_CFG?ACTION=IPNAMECACHE&TODO=RESET">Reset IPname cache? </a><hr width="30%">'
if params.!TODO='RESET' then do
    foo=sre_cache_write('!CLIENTNAME','!RESET')
    call lineout tempfile,'<em>Username/password cache will be cleared ... </em>'
    call lineout tempfile,'<hr> <a href="/sre2_cfg?">Return to Sre2000 parameter viewer </a>'
    call lineout tempfile,'</BODY></HTML>'
    aa=sref_gos('FILE ERASE type text/html name 'tempfile)
    return aa
end 

foo=sre_cache_ipname('!INFO')
call lineout tempfile,'<pre>'||foo
call lineout tempfile,'</pre>'
call lineout tempfile,'<hr> <a href="/sre2_cfg?">Return to Sre2000 parameter viewer </a>'
call lineout tempfile,'</BODY></HTML>'
call lineout tempfile
aa=sref_gos('FILE ERASE type text/html name 'tempfile)
return aa



/******************************************/
/* the Request Cache viewer */
do_reqcache:


 aa1=sre_sysvars('REQ_CACHE_ENABLE')
 aa2=sre_sysvars('REQ_CACHE_SIZE')
 aa3=sre_sysvars('REQ_CACHE_VERIFY')
 aa4=sre_sysvars('REQ_CACHE_CALL_ANYWAYS')
if params.!DOSTUFF=1 then signal req_cache2


call lineout tempfile,'<HTML><HEAD><TITLE>Viewing the Sre2000  Request Cache </TITLE></head>'
call lineout tempfile,'<BODY><h2>Viewing the Sre2000 Request Cache </h2>'
call lineout tempfile,'<center><em>'||date('n')||' '||time('n')||'</em></center>'
call lineout tempfile,'<FORM ACTION="/SRE2_CFG" METHOD="GET">'

call lineout tempfile,'<Input type="hidden" name="ACTION" value="REQCACHE">'
call lineout tempfile,'<Input type="hidden" name="DOSTUFF" value="1">'

call lineout tempfile,'<table><tr><td><B>Cache enabled:</b> </td>'
if aa1=1 then   call lineout tempfile,'<td> <tt>Enabled</tt>'
if aa1=0 then   call lineout tempfile,'<td> <tt>Disabled</tt>'

call lineout tempfile,'<tr><td><B>Cache verification:</b> </td>'
if aa3=1 then   call lineout tempfile,'<td> <tt>Enabled </tt> </td>'
if aa3=2 then   call lineout tempfile,'<td> <tt>Flexible-Enabled </tt> </td>'
if aa3=3 then   call lineout tempfile,'<td> <tt>Disabled </tt></td>'


call lineout tempfile,'<tr><td><STRONG>Cache size:</STRONG> </td>'
call lineout tempfile,'<td><tt>'aa2 '</tt></td>'
 
call lineout tempfile,'<tr><td><STRONG>Cache Call Anyways:</STRONG> </td>'
call lineout tempfile,'<td><tt>'aa4 '</tt></td>'

call lineout tempfile,'</table><hr width="50%"> '

if aa1=1 then do
   efoo=sre_req_cache('!INFO')

   parse var efoo nentries '0d0a'x efoo
   call lineout tempfile,'<table>'
  
   do mm=1 to nentries
      parse var efoo aline '0d0a'x efoo
      parse var aline  a1 '//' aurl afname astamp atype atag .
      parse var a1 . hitct hnick
      if mm//2==1 then
         bgg="#889988"
      else      
         bgg="#55aa88"
      call lineout tempfile,'<tr bgcolor="'bgg'"><td><INPUT TYPE="CHECKBOX" NAME="remove" VALUE="'HNICK||'//'||aurl'" > '
      call lineout tempfile,'<font size="-1">'mm')</font></td>'
      call lineout tempfile,'<td><tt>'hnick'//</tt> <b>'aurl'</b></td>'
      call lineout tempfile,'<td><tt>'afname'</tt><br><tt>'astamp'</tt></td>'
      call lineout tempfile,'<td>'atype'</td><td>'atag'</td><td><em>'hitct' &nbsp; </em> </td>'
   end 
   call lineout tempfile,'</table>'
end
call lineout tempfile,'<br>'
call lineout tempfile,'<SELECT NAME="DELETEALL" SIZE="1" >'
call lineout tempfile,'<OPTION SELECTED  value="1" >Delete Selected Entries'
call lineout tempfile,'<OPTION value="2" >Delete All entries'
call lineout tempfile,'</SELECT> &nbsp; &nbsp; '

call lineout tempfile,'<INPUT type="SUBMIT" value=" ... delete entries">'
call lineout tempfile,'<INPUT type="Reset" >'


call lineout tempfile,'</FORM>'
call lineout tempfile,'<hr> <a href="/sre2_cfg?">Return to Sre2000 parameter viewer </a>'
call lineout tempfile,'</BODY></HTML>'
call lineout tempfile
aa=sref_gos('FILE ERASE type text/html name 'tempfile)
return aa

/****** Jump here if something to do (i.e.; remove an entry */
req_cache2:


call lineout tempfile,'<HTML><HEAD><TITLE>Viewing the Sre2000 Request Cache </TITLE></head>'
call lineout tempfile,'<BODY><h2>Removing entries from the Sre2000 Request Cache </h2>'
call lineout tempfile,'<center><em>'||date('n')||' '||time('n')||'</em></center>'

call lineout tempfile,'<ul>'
ndid=0

if params.!DELETEALL=2 then do
      caoo=sre_cache_write('!RESET',strip(aaurl))
       if caoo='' then  do
          call lineout tempfile,'<li> <em>Unable to delete all entries </em> </ul>'
       end
       else do
          call lineout tempfile,'<li> <b>All entries will be removed</b></ul>'
       end 
      call lineout tempfile,"<p><b>Current cache status: </b><br>"
      foo=sre_cache_write('!PRUNE2')
      call syssleep(2)
      foo=sre_req_cache('!STATUS')
      call lineout tempfile,'&nbsp; &nbsp; 'foo
      call lineout tempfile,'</ul>'
      call lineout tempfile,'<hr> <a href="/sre2_cfg?">Return to Sre2000 parameter viewer </a>'
      call lineout tempfile,'</BODY></HTML>'

      call lineout tempfile
      aa=sref_gos('FILE ERASE type text/html name 'tempfile)
      return aa
end

/* not a reset -- check for individual removes */
lls.='' ;ills=0
do until list=''
   parse var list a1 '&' list
   parse var a1 a1a '=' a1b
   if strip(translate(a1a))<>'REMOVE' then iterate
   ills=ills+1
   lls.ills=a1a
   lls.ills.!what=a1b
end   

do im=1 to ills
   a1a=lls.im
   a1b=lls.im.!what
   ndid=ndid+1

   caoo=sre_cache_write('!REMOVE',translate(strip(a1b)))
   if caoo='' then  do
      call lineout tempfile,'<li><tt>'a1b'</tt> : <em>no such cache entry! </em> '
   end
   else do
      call lineout tempfile,'<li><tt>'a1b'</tt> : <b>removed</b>'
   end 
end 
if ndid=0 then do
  call lineout tempfile,'<b>No entries specified</b>'
end
else do
   call lineout tempfile,"<p><b>Current cache status: </b><br>"
  foo=sre_cache_write('!PRUNE2')
  call syssleep(2)
  foo=sre_req_cache('!STATUS')
  call lineout tempfile,'&nbsp; &nbsp; 'foo
end 

call lineout tempfile,'</ul>'
call lineout tempfile,'<hr> <a href="/sre2_cfg?">Return to Sre2000 parameter viewer </a>'

call lineout tempfile,'</BODY></HTML>'
call lineout tempfile
aa=sref_gos('FILE ERASE type text/html name 'tempfile)
return aa


/******************************************/
/* md5 cache viewer */
do_md5cache:

if params.!DOSTUFF=1 then signal md5_cache2

call lineout tempfile,'<HTML><HEAD><TITLE>Viewing the Sre2000 MD5 Cache </TITLE></head>'
call lineout tempfile,'<BODY><h2>Viewing the Sre2000 MD5 Cache </h2>'
call lineout tempfile,'<center><em>'||date('n')||' '||time('n')||'</em></center>'

call lineout tempfile,'<FORM ACTION="/sre2_cfg" METHOD="GET">'
call lineout tempfile,'<Input type="hidden" name="DOSTUFF" value="1">'
call lineout tempfile,'<Input type="hidden" name="ACTION" value="MD5CACHE">'

efoo=sre_md5s_cache('!STATUS')
call lineout tempfile,'<p><Pre>'efoo'</pre>'

efoo=sre_md5s_cache('!INFO')
parse var efoo nentries '0d0a'x efoo
call lineout tempfile,'<table>'
  
do mm=1 to nentries
      parse var efoo aline '0d0a'x efoo
      parse var aline .  nct afile amd5 datestamp
      if mm//2==1 then
         bgg="#889988"
      else      
         bgg="#55aa88"
      call lineout tempfile,'<tr bgcolor="'bgg'"><td><INPUT TYPE="CHECKBOX" NAME="remove" VALUE="'afile'" > '
      call lineout tempfile,'<font size="-1">'mm')</font></td>'
      call lineout tempfile,'<td><b>'afile'</b></td>'
      call lineout tempfile,'<td><tt>'amd5'</tt> <em>'nct' </em> </td>'
end 
call lineout tempfile,'</table>'
call lineout tempfile,'<br>'
call lineout tempfile,'<SELECT NAME="DELETEALL" SIZE="1" >'
call lineout tempfile,'<OPTION SELECTED  value="1" >Delete Selected Entries'
call lineout tempfile,'<OPTION value="2" >Delete All entries'
call lineout tempfile,'</SELECT> &nbsp; &nbsp; '

call lineout tempfile,'<INPUT type="SUBMIT" value="Delete Selected Entries">'
call lineout tempfile,'<INPUT type="Reset" >'

call lineout tempfile,'</FORM>'
call lineout tempfile,'<hr> <a href="/sre2_cfg?">Return to Sre2000 parameter viewer </a>'

call lineout tempfile,'</BODY></HTML>'

call lineout tempfile
aa=sref_gos('FILE ERASE type text/html name 'tempfile)
return aa

/****** Jump here if something to do (i.e.; remove an entry */

md5_cache2:

call lineout tempfile,'<HTML><HEAD><TITLE>Viewing the Sre2000 MD5 Cache </TITLE></head>'
call lineout tempfile,'<BODY><h2>Removing entries from the Sre2000 MD5 Cache </h2>'
call lineout tempfile,'<center><em>'||date('n')||' '||time('n')||'</em></center>'


if params.!DELETEALL='2' then do
   caoo=sre_cache_write('!MD5!RESET',strip(aaurl))
   if caoo='' then  do
          call lineout tempfile,'<li> <em>Unable to delete all entries </em> </ul>'
   end
   else do
          call lineout tempfile,'<li> <b>All entries will be removed</b></ul>'
   end 
   call lineout tempfile,"<p><b>Current cache status: </b><br>"
   foo=sre_cache_write('!PRUNE2')
   call syssleep(2)
   foo=sre_md5s_cache('!STATUS')
   call lineout tempfile,'&nbsp; &nbsp; 'foo
   call lineout tempfile,'<hr> <a href="/sre2_cfg?">Return to Sre2000 parameter viewer </a>'
   call lineout tempfile,'</BODY></HTML>'
   call lineout tempfile
    aa=sref_gos('FILE ERASE type text/html name 'tempfile)
   return aa
end

call lineout tempfile,'<ul>'
ndid=0

lls.='' ;ills=0
do until list=''
   parse var list a1 '&' list
   parse upper var a1 a1a '=' a1b 
   if strip(translate(a1a))<>'REMOVE' then iterate
   ills=ills+1
   lls.ills=a1a
   lls.ills.!what=a1b
end   

do im=1 to ills
   a1a=lls.im
   a1b=lls.im.!what
   ndid=ndid+1
   caoo=sre_cache_write('!MD5!REMOVE',translate(strip(a1b)))
   if caoo='' then  do
      call lineout tempfile,'<li><tt>'a1b'</tt> : <em>no such MD5 cache entry! </em> '
   end
   else do
      call lineout tempfile,'<li><tt>'a1b'</tt> : <b>MD5 removed</b>'
   end 
end 
if ndid=0 then do
  call lineout tempfile,'<b>No entries specified</b>'
end
else do
   call lineout tempfile,"<p><b>Current cache status: </b><br>"
  foo=sre_cache_write('!PRUNE2')
  call syssleep(2)
  foo=sre_req_cache('!STATUS')
  call lineout tempfile,'&nbsp; &nbsp; 'foo
end 

call lineout tempfile,'</FORM>'
call lineout tempfile,'<hr> <a href="/sre2_cfg?">Return to Sre2000 parameter viewer </a>'
call lineout tempfile,'</BODY></HTML>'

call lineout tempfile
aa=sref_gos('FILE ERASE type text/html name 'tempfile)
return aa




/******************************************/
/* select variables set to view/change */
do_srecfg:procedure expose tempfile

call lineout tempfile,'<HTML><HEAD><TITLE>Sre2000 parameter viewer </TITLE></head>'
call lineout tempfile,'<BODY><h2>Select a cache, or set of parameters, to view &amp; modify </h2>'

call lineout tempfile,'<FORM ACTION="/sre2_cfg" METHOD="GET">'

call lineout tempfile,'<ul>'

call lineout tempfile,'<OL>'
call lineout tempfile,'<LI><INPUT TYPE=RADIO NAME="ACTION" VALUE="reqcache">Request Cache '
call lineout tempfile,'<LI><INPUT TYPE=RADIO NAME="ACTION" VALUE="md5cache">MD5 Cache '
call lineout tempfile,'<LI><INPUT TYPE=RADIO NAME="ACTION" VALUE="usercache">Username/password cache '
call lineout tempfile,'<LI><INPUT TYPE=RADIO NAME="ACTION" VALUE="ipnamecache">IPName cache '
call lineout tempfile,'<LI><INPUT TYPE=RADIO NAME="ACTION" VALUE="counters">Counter variables '
call lineout tempfile,'<LI><INPUT TYPE=RADIO NAME="ACTION" VALUE="sysvars">System variables '
call lineout tempfile,'<LI><INPUT TYPE=RADIO NAME="ACTION" VALUE="statvals">Recent stats '
call lineout tempfile,'<LI><INPUT TYPE=RADIO NAME="ACTION" VALUE="clients">Current clients '
foo=sre_sysvars('TRACKING_ON')
if foo=1 then call lineout tempfile,'<LI><INPUT TYPE=RADIO NAME="ACTION" VALUE="tracking">Current clients -- tracking info '

call lineout tempfile,'</OL>'


call lineout tempfile,'<INPUT TYPE="submit" VALUE="Choose an action">'
call lineout tempfile,'</form>'
call lineout tempfile
foo=sref_gos('FILE erase type text/html name 'tempfile)
return foo

/******************************************/
/* is user allowed to run this? */
check_access:procedure expose tempfile servername
parse arg privset,checkit

NO_REM=VALUE('SREF_NO_REMOTE_CONFIG',,'OS2ENVIRONMENT')

/* stringent "no remote configuration? */
if no_rem=1 |  checkit =2 then do
        call lineout tempfile, '<!doctype html public "-//IETF//DTD HTML 3.0//EN">'
        call lineout tempfile, "<html><head><title>Not permitted </title>"
        call lineout tempfile, '</head><body>'
        call lineout tempfile,'<br> <Em>Web-based configuration is suppressed </em> '
        call lineout tempfile,' </body> </html> '
        call lineout tempfile
        foo=sref_gos('FILE ERASE TYPE text/html NAME' tempfile)
        return foo
end 

who2=extract('CLIENTADDR')
saddr2=extract('SERVERADDR')

/* stringent "no remote configuration? */
if (no_rem=2 |  checkit =1)  & (who2<>saddr2) then do
        call lineout tempfile, '<!doctype html public "-//IETF//DTD HTML 3.0//EN">'
        call lineout tempfile, "<html><head><title>Not authorized </title>"
        call lineout tempfile, '</head><body>'

        call lineout tempfile,'<br> <Em>Remote configuration is suppressed </em> '

        call lineout tempfile,' </body> </html> '
        call lineout tempfile
        foo=sref_gos('FILE ERASE TYPE text/html NAME' tempfile)
        return foo
end 

/* check for superuser privs */
if wordpos('SUPERUSER',privset)=0 then do

   foo=sre_command('header add WWW-Authenticate: Basic Realm=<Configure>')  /* challenge */
   call lineout tempfile, '<!doctype html public "-//IETF//DTD HTML 3.0//EN">'
   call lineout tempfile, "<html><head><title>Not authorized </title>"
   call lineout tempfile, '</head><body>'

   call lineout tempfile,' <strong> You do not have configuration rights.</strong> '

   call lineout tempfile,' </body> </html> '
   call lineout tempfile
      
   return sref_response('unauth', "You do not have configuration rights ",servername)
end

return ' '



badguys:
call pmprintf(" Error in SRE2_CFG at line "sigl' == 'rc)
exit

